#!/usr/bin/env python3
import rclpy

from {{ pkgname }}.{{ skill }}_abstract_manager import Abstract{{ skill.name|action_name }}Manager

class {{ skill.name|action_name }}Manager(Abstract{{ skill.name|action_name }}Manager):

    def __init__(self):
        super().__init__()
        '''
        Here you can add publisher/subscriber or other specific elements to
        interact with the other nodes of your architecture
        '''
    
    '''
    def validate(self, goal):
        You must redefine the validation hook and return True if you
        accept the incoming goal, or False otherwise.
        return True
    '''

    '''
    def on_dispatch(self, goal_id, goal):
        You must redefine the dispatch hook in order to activate the
        skill execution on you architecture, e.g., by publishing some information
        taken from the goal, to a ROS topic.
        When the execution is finished (whatever its final state), you must call
        the terminate method corresponding to the final state. Available terminate
        methods of your skill are:
        {% for result in skill.results %}
        self.terminated_{{ result }}(goal_id)
        {%- endfor %}
    '''

    '''
    def on_interrupt(self, goal_id, goal):
        You must redefine the interrupt hook in order to interrupt the
        skill execution on you architecture, e.g., by publishing some information
        to a ROS topic.
        When the skill is interrupted, you must call the terminate method
        corresponding to the final state, among:
        {% for result in skill.results %}
        self.terminated_{{ result }}(goal_id)
        {%- endfor %}
    '''

    '''
    def progress(self, goal_id, goal):
        You must redefine the progress hook in order to send a progress
        information on the execution of the skill, in the form of a float value
        between 0 (just started) and 1 (completed). If you don't know what to return,
        just return 1/2:
        return .5
    '''

    {% for effect in skill.effects %}
    '''
    def on_effect_{{ effect.name }}(self):
        This hook will be called on the application of effect {{ effect.name }}.
        You can interact with your architecture in this function.
    '''
    {% endfor %}

''' Don't change the main function unless you know what you do '''
def main(args=None):
    rclpy.init(args=args)
    server = {{ skill.name|action_name }}Manager()
    server.get_logger().info("Manager created")
    server.spin()

if __name__ == '__main__':
    main()
